Leetcode 1. Two Sum (Hashmap)

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the sameelement twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

 

这题不难,首先想到的就是暴力遍历,用两个for循环就能做出来,但是时间太长。时间复杂度为O(n^2)。

 

后来也是看了其他人的解法,发现用HashMap的思想会比较快。最坏情况为O(n)。

C++版:

 

Python版:

#Solution2
def twoSum(self, nums, target):
    """
    :type nums: List[int]
    :type target: int
    :rtype: List[int]
    """
    n = len(nums)
    dic = {}
    for x in range(n):
        a = target - nums[x]
        if nums[x] in dic:          #关键步骤
            return dic[nums[x]], x
        else:
            dic[a] = x;

 

实例步骤如下:

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值